LeetCode_138_MaximumLengthOfRepeatedSubarray


1. question: 最长公共子数组(中等)

给两个整数数组 nums1 和 nums2 ,返回 两个数组中 公共的 、长度最长的子数组的长度 。

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/maximum-length-of-repeated-subarray

示例 1:

1
2
3
输入:nums1 = [1,2,3,2,1], nums2 = [3,2,1,4,7]
输出:3
解释:长度最长的公共子数组是 [3,2,1] 。

示例 2:

1
2
输入:nums1 = [0,0,0,0,0], nums2 = [0,0,0,0,0]
输出:5

提示:

1
2
1 <= nums1.length, nums2.length <= 1000
0 <= nums1[i], nums2[i] <= 100

2. answers

这道题要求是找两个数组的公共子数组,本质上和前面的最长子数组类似。可采用动态规划的思路来做。定义数组dp[i][j],表示以i、j结尾的公共子数组的长度。显然状态转移方程为:

  1. dp[i][j] = dp[i-1][j-1] + 1;

但是如果要进行状态转移,首先要满足的条件就是i和j两个元素相同,这样才能是公共子数组的结尾,否则dp[i][j]=0。另外,对于dp[i][0]和dp[0][j]该怎么做呢?要么是单独赋值,要么是新增维度,为了简单起见,这里新增一个维度。

这里可能会有疑问,就是只要求了以该元素结尾,那么子数组的开头是什么元素呢?其实,当子数组的长度为0时,那么当前结尾元素就是开头元素;所以说,子数组就是由若干次的结尾元素形成的。

代码如下所示:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
public class Solution_0138 {

public int findLength(int[] nums1, int[] nums2) {

int[][] dp = new int[nums1.length + 1][nums2.length + 1];

// 注意,此时的i和j,对应在dp数组中的位置
int max = 0;
for (int i = 0; i < nums1.length; i++) {

for (int j = 0; j < nums2.length; j++) {
if(nums1[i] == nums2[j]) {
dp[i+1][j+1] = dp[i][j] + 1;
max = Math.max(max, dp[i+1][j+1]);
}
}
}

return max;
}

public static void main(String[] args) {
System.out.println();

Solution_0138 s = new Solution_0138();

// int[] nums1 = {1,2,3,2,1};
// int[] nums2 = {3,2,1,4,7};

int[] nums1 = {0,0,0,0,0};
int[] nums2 = {0,0,0,0,0};

System.out.println(s.findLength(nums1, nums2));
}
}

由上面可以看出,下一行的状态仅取决于上一行,所以可采用一维数组来动态更新,代码如下所示:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
public class Solution_0138_02 {

public int findLength(int[] nums1, int[] nums2) {

// 每遍历nums1中的一个元素,就更新一次dp
// 表明以nums1元素结尾时,以nums2[j]中元素结尾时的公共数组
int[] dp = new int[nums2.length + 1];
Arrays.fill(dp, 0);

// 注意,此时的i和j,对应在dp数组中的位置
int max = 0;
for (int i = 0; i < nums1.length; i++) {

// 注意,逆序遍历
for (int j = nums2.length; j > 0; j--) {

if(nums1[i] == nums2[j - 1]) {
dp[j] = dp[j-1] + 1;
max = Math.max(max, dp[j]);

}
else dp[j] = 0;
}
}

return max;
}

public static void main(String[] args) {
System.out.println();

Solution_0138_02 s = new Solution_0138_02();

int[] nums1 = {1,2,3,2,1};
int[] nums2 = {3,2,1,4,7};

// int[] nums1 = {0,0,0,0,0};
// int[] nums2 = {0,0,0,0,0};

System.out.println(s.findLength(nums1, nums2));
}
}

3. 备注

参考力扣(LeetCode)官网 - 全球极客挚爱的技术成长平台 (leetcode-cn.com)代码随想录 (programmercarl.com)


文章作者: 浮云
版权声明: 本博客所有文章除特別声明外,均采用 CC BY 4.0 许可协议。转载请注明来源 浮云 !
  目录